/* ***********************************************************************
   *                                                                     *
   *                               CuntLits                              *
   *                                                                     *
   *  Application for performing various manipulations on M$ .lit files  *
   *  and other boring stuff.  This is a clit with 32 bits, gui created  *
   *  for the Fuzzy One's unix version.  12/08/2002                      *
   *               Rewrite: 12/18/2002 -- Stopped playing around.        *
   *********************************************************************** */
#include <windows.h>
#include <shellapi.h>
#include "AggressiveOptimize.h"
#include "cuntcont.h"
#include "cuntlits.h"  /* Variables, prototypes, etc for the clit */
#include "cunterror.h"


/*.----------------------------------------------------------------------- 
  |WinMain : 
  |        : Application entry point
  |_______________________________________________________________________
 */
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
HWND hwnd;             /* My creativity knows no bounds. */
HWND existing = NULL;  /* HWND used to check that only one instance is running. */
MSG msg;               /* MSG var for main message loops  */
gInst = hInstance;     /* Global var to track instance: Should almost always be 0x400000 */

    /* If we've already got a cunt, show it instead of creating a new one.  */
    existing = FindWindow(APPNAME, NULL);
    if (existing) {
        ShowWindow(existing,SW_RESTORE);
        SetForegroundWindow(existing);
    } else {

        /* Find screen dimensions so we can center our cunt */
        SCRW = GetSystemMetrics(SM_CXSCREEN);                /* Get Screen Width */
        SCRH = GetSystemMetrics(SM_CYSCREEN);                /* Get Screen Height */

        if (! SCRW || !SCRH ) {
            MessageBox(NULL, "Unable to determine size of your screen.", NULL, 0);
            PostQuitMessage(ERROR);
        }

        /* Register the class */
        if (! RegisterWinClass((WNDPROC)WndProc, hInstance, APPNAME) ) {
            MessageBox(NULL, "Fatal Error: Couldn't create a custom cunt.  Terminating in disappointment.", NULL, 0);
            PostQuitMessage(ERROR);
        }

        /*+. 
           | Create Main Window : 
           |                    : Creates a standard looking windows window
           |                    : with the caveat that we really don't want
           |                    : to deal with resizing the controls, so we don't
           |                    : allow maximizing or resizing the border.
          */
        hwnd = CreateWindowEx(WS_EX_ACCEPTFILES, APPNAME, APPTIT,
                              WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX | WS_VISIBLE,
                              SCRN_CNTR(SCRW,APPW),SCRN_CNTR(SCRH,APPH), APPW, APPH, NULL, NULL, gInst, NULL);
    
        ShowWindow(hwnd, SW_SHOWNORMAL);  /* And Lo, there was form. */
        UpdateWindow(hwnd);               
    }


    /* Polling: How 1980s. */ 
    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;  
} // WinMain

 /*.-----------------------------------------------------------------------
   |WndProc :
   |        : Handles all the WM_x messages
   |_______________________________________________________________________
 */
LRESULT CALLBACK WndProc(HWND hWin, UINT wMsg, WPARAM wParam, LPARAM lParam) {

    /* wMsg contains the WM_? ID */ 
    switch (wMsg) {

    /* Actions we define */
    case WM_COMMAND:
        switch (wParam) {
            /* Get name of a .lit file */
            case OPENCLIT: 
                if (GetFile(hWin, gInst, ofn,(char *) szFullPath,(char *) szFileName)) {
                    SendMessage(hFilePath, WM_SETTEXT, 0,(WPARAM) szFullPath);
                }
            break;

            case CONVERTL: /* Convert Lit Button Click */
                if (! GetWindowText(hFilePath, (char *)szFullPath, MAXPATHLEN) ) {
                    lMsg(EMPTYPATHE, FALSE);
                } else {
                    ConvertLit((char *)szFullPath, (char *)szFullPath, hStaticMsg);
                }
            break;

            case EXTRACTL: /* Extract Lit Button Click */
                if (! GetWindowText(hFilePath, (char *)szFullPath, MAXPATHLEN) ) {
                    lMsg(EMPTYPATHE, FALSE);
                } else {
                    LitToHtml((char *)szFullPath, (char *)szFullPath, hStaticMsg);
                }
            break;

            case LITINSCR: /* Inscribe */
                MessageBox(NULL, "Sorry, inscribing not implemented yet. Someone's laaaaaayzeee. Or something.", "Shoot.", 0);
            break;

            case ADVANCED: /* Options */
                MessageBox(NULL, "Advanced Options not coded yet... not absolutely necessary, don't fret.  (While un-needed, will add convenience, so you won't have to set up for no hands mode. ", "Darn.", 0);
            break;

            case ABOUTAPP: /* About */
                ShellAbout(hWin,"CuntLits: Convert Until Now Transformed Lit(s).#Bill Gates eats platypus faeces.",
                "This app is Freeware, and may be masturbated with by permission of The Evil Empire, Redmond, Washington.\nCopyright  Fuzzy Rectum Software 2002",NULL);
            break;

        } // switch(wParam)
    break;

    /* (Pro) Creation */
    case WM_CREATE:
        if (! (tb = CreateClitBar(hWin, gInst)) ) { // Create our toolbar 
            lMsg(BUTTCREATE, TRUE);
            }
        CreateStatics(hWin, globhands, &currHwnd); 
        hStaticMsg = globhands[currHwnd-1]; /* Handle of static error message */
        CreateEdits(hWin, globhands, &currHwnd);
        hFilePath = globhands[currHwnd-1];  /* Should be handle to edit box for filepath */
        CreateListDisplay(hWin);   /* Create the list report view */

    break;

    /* Destructor */
    case WM_DESTROY:

        /* Get rid of anything we've declared. Need to check more
           seriously for memory leaks later. */
        while (currHwnd > 0) {  
            DeleteObject(globhands[currHwnd--]);
        }

        PostQuitMessage(0);

    break;

    /* Handle the system colors changing, since we want transparentish buttons*/
    case WM_SYSCOLORCHANGE:
        /* Destroy anything with kludged backgrounds */
        DeleteObject(tb);

        /* And recreate them */
        if (! (tb = CreateClitBar(hWin, gInst)) ) { // Create our toolbar 
            lMsg(BUTTCREATE, TRUE);
            }

    break;
    /* And if we don't process, be nice, and let Windows. Hey, Billy likes it! */
    default:
        return DefWindowProc(hWin,wMsg,wParam,lParam);
   }

   return DefWindowProc(hWin,wMsg,wParam,lParam);
} // WndProc








